#define Display_X LATB

#define X0 LATB.F0
#define X1 LATB.F1
#define X2 LATB.F2
#define X3 LATB.F3
#define X4 LATB.F4
#define X5 LATB.F5
#define X6 LATB.F6
#define X7 LATB.F7

#define Y0 LATC.F0
#define Y1 LATC.F1
#define Y2 LATC.F2
#define Y3 LATC.F3
#define Y4 LATC.F4
#define Y5 LATC.F5
#define Y6 LATC.F6
#define Y7 LATC.F7
#define Y8 LATD.F0
#define Y9 LATD.F1
#define YA LATD.F2
#define YB LATD.F3
#define YC LATD.F4
#define YD LATD.F5
#define YE LATD.F6
#define YF LATD.F7

#define Buzzer    LATE.F0

#define UP_Key    PORTA.F0
#define DOWN_Key  PORTA.F1
#define RIGHT_Key PORTA.F2
#define LEFT_Key  PORTA.F3

#define Turbo_Key  PORTA.F4
#define Pause_Key  PORTA.F5

void Beep(unsigned char ON_Time,unsigned char OFF_Time,unsigned char NUM_Time);
void Display_Y_Select(signed char Y_Var);
void Snake_Position_Check();
void Read_Vectorial_Keys();
void Read_Function_Keys();
void Display_UpDate();
void Snake_UpDate();
void Create_Food();
void Snake_Incr();
void Next_Level();
void Init_Game();

enum Vector {UP,DOWN,RIGHT,LEFT} Vectorial;

    bit Snake_UpDated,Food_Error,Food_Show,Pause,Pause_Pressed;
    signed char Snake_X[15],Snake_Y[15];
    unsigned int Timer,Level,Speed;
    unsigned char Snake_Size;
    signed int Food_X,Food_Y;
    unsigned char Ring;
         
void main() {

  ADCON1=0x06;
  TRISA=0xFF;
  TRISB=0x00;
  TRISC=0x00;
  TRISD=0x00;
  TRISE=0x00;
  
  Init_Game();
  Level = 500;
  
  while(1) {
  
    LATC=0;
    LATD=0;
    Display_X=Display_X<<1;
    Display_X.F0=C_Bit;

    Read_Vectorial_Keys();
    Read_Function_Keys();
    
    ++Timer;
    if(Timer>=Speed) {

      Timer=0;
      Snake_UpDate();
    }
    Display_UpDate();

    delay_ms(1);
  }
}

void Display_UpDate() {

  if(!X0) {

    for(Ring=0;Ring<Snake_Size;Ring++) {
    
      if(Snake_X[Ring]==0) Display_Y_Select(Snake_Y[Ring]);
      if(Food_X==0 && Food_Show) Display_Y_Select(Food_Y);
    }
  }else if(!X1) {

    for(Ring=0;Ring<Snake_Size;Ring++) {
    
      if(Snake_X[Ring]==1) Display_Y_Select(Snake_Y[Ring]);
      if(Food_X==1 && Food_Show) Display_Y_Select(Food_Y);
    }
  }else if(!X2) {

    for(Ring=0;Ring<Snake_Size;Ring++) {
    
      if(Snake_X[Ring]==2) Display_Y_Select(Snake_Y[Ring]);
      if(Food_X==2 && Food_Show) Display_Y_Select(Food_Y);
    }
  }else if(!X3) {

    for(Ring=0;Ring<Snake_Size;Ring++) {
    
      if(Snake_X[Ring]==3) Display_Y_Select(Snake_Y[Ring]);
      if(Food_X==3 && Food_Show) Display_Y_Select(Food_Y);
    }
  }else if(!X4) {

    for(Ring=0;Ring<Snake_Size;Ring++) {
    
      if(Snake_X[Ring]==4) Display_Y_Select(Snake_Y[Ring]);
      if(Food_X==4 && Food_Show) Display_Y_Select(Food_Y);
    }
  }else if(!X5) {

    for(Ring=0;Ring<Snake_Size;Ring++) {
    
      if(Snake_X[Ring]==5) Display_Y_Select(Snake_Y[Ring]);
      if(Food_X==5 && Food_Show) Display_Y_Select(Food_Y);
    }
  }else if(!X6) {

    for(Ring=0;Ring<Snake_Size;Ring++) {
    
      if(Snake_X[Ring]==6) Display_Y_Select(Snake_Y[Ring]);
      if(Food_X==6 && Food_Show) Display_Y_Select(Food_Y);
    }
  }else if(!X7) {

    for(Ring=0;Ring<Snake_Size;Ring++) {
    
      if(Snake_X[Ring]==7) Display_Y_Select(Snake_Y[Ring]);
      if(Food_X==7 && Food_Show) Display_Y_Select(Food_Y);
    }
  }
}

void Display_Y_Select(signed char Y_Var) {

  switch(Y_Var) {

    case 0:  Y0=1; break;
    case 1:  Y1=1; break;
    case 2:  Y2=1; break;
    case 3:  Y3=1; break;
    case 4:  Y4=1; break;
    case 5:  Y5=1; break;
    case 6:  Y6=1; break;
    case 7:  Y7=1; break;
    case 8:  Y8=1; break;
    case 9:  Y9=1; break;
    case 10: YA=1; break;
    case 11: YB=1; break;
    case 12: YC=1; break;
    case 13: YD=1; break;
    case 14: YE=1; break;
    case 15: YF=1;
  }
}

void Snake_UpDate() {

  if(!Pause) {
  
    for(Ring=Snake_Size-1;Ring>0;Ring--) {
  
      Snake_X[Ring]=Snake_X[Ring-1];
      Snake_Y[Ring]=Snake_Y[Ring-1];
    }
    switch(Vectorial) {
  
      case UP:    Snake_Y[0]-=1; break;
      case Down:  Snake_Y[0]+=1; break;
      case RIGHT: Snake_X[0]+=1; break;
      case LEFT:  Snake_X[0]-=1;
    }
    if(Snake_X[0]==Food_X && Snake_Y[0]==Food_Y) Snake_Incr();

    if(Snake_Size==15) Next_Level();

    Snake_Position_Check();
    Snake_UpDated = 1;
    Beep(10,0,1);
  }
  Food_Show= ~Food_Show;
}

void Read_Vectorial_Keys() {

  if(Snake_UpDated==1 && !Pause) {

    if(!UP_Key && Vectorial!=DOWN) {
    
      Vectorial = UP;
      Snake_UpDated = 0;

    }else if(!DOWN_Key && Vectorial!=UP) {
    
      Vectorial = DOWN;
      Snake_UpDated = 0;

    }else if(!RIGHT_Key && Vectorial!=LEFT) {
    
      Vectorial = RIGHT;
      Snake_UpDated = 0;

    }else if(!LEFT_Key && Vectorial!=RIGHT) {
    
      Vectorial = LEFT;
      Snake_UpDated = 0;
    }
  }
}

void Read_Function_Keys() {

  if(!Turbo_Key) Speed = Level/2;
  else Speed = Level;
  
  if(!Pause_Key && !Pause_Pressed) {

   Pause_Pressed = 1;
   Pause = ~Pause;
  
  }else if(Pause_Key) Pause_Pressed = 0;
  
}

void Beep(unsigned char ON_Time,unsigned char OFF_Time,unsigned char NUM_Time) {

  for(NUM_Time;NUM_Time>0;NUM_Time--) {
   
    Buzzer = 1;
    Vdelay_ms(ON_Time);
    Buzzer = 0;
    Vdelay_ms(OFF_Time);
  }
}

void Create_Food() {

  do {

    Food_X = rand()/4096;
    Food_Y = rand()/2048;
    Food_Error = 0;
    
    for(Ring=0;Ring<Snake_Size;Ring++) {
  
      if(Food_X==Snake_X[Ring] && Food_Y==Snake_Y[Ring]) {
    
        Food_Error = 1;
        break;
      }
    }
  }while(Food_Error==1);
}

void Snake_Incr() {

  ++Snake_Size;
  
  for(Ring=Snake_Size-1;Ring>0;Ring--) {

    Snake_X[Ring]=Snake_X[Ring-1];
    Snake_Y[Ring]=Snake_Y[Ring-1];
  }
  Create_Food();
  Beep(10,10,1);
}

void Snake_Position_Check() {

  if(Snake_X[0]>7 || Snake_X[0]<0 || Snake_Y[0]>15 || Snake_Y[0]<0) {
  
    Init_Game();
    Level = 500;
   
  }else {
  
    for(Ring=2;Ring<Snake_Size;Ring++) {
  
      if(Snake_X[0]==Snake_X[Ring] && Snake_Y[0]==Snake_Y[Ring]) {
      
        Init_Game();
        Level = 500;
      }
    }
  }
}

void Init_Game() {

  Vectorial = DOWN;
  Snake_Size = 4;

  Create_Food();

  Snake_X[3]=0;
  Snake_Y[3]=0;
  Snake_X[2]=0;
  Snake_Y[2]=1;
  Snake_X[1]=0;
  Snake_Y[1]=2;
  Snake_X[0]=0;
  Snake_Y[0]=3;

  Display_X=254;
  
  Beep(10,10,3);
}

void Next_Level() {

  Init_Game();
  
  Level*=0.8;
  if(Level<10) Level = 500;
  
  Beep(50,50,4);
}