#line 1 "D:/Electronic/My Projects/PIC/Snake/Snake.c"
#line 39 "D:/Electronic/My Projects/PIC/Snake/Snake.c"
void Beep(unsigned char ON_Time,unsigned char OFF_Time,unsigned char NUM_Time);
void Display_Y_Select(signed char Y_Var);
void Snake_Position_Check();
void Read_Vectorial_Keys();
void Read_Function_Keys();
void Display_UpDate();
void Snake_UpDate();
void Create_Food();
void Snake_Incr();
void Next_Level();
void Init_Game();

enum Vector {UP,DOWN,RIGHT,LEFT} Vectorial;

 bit Snake_UpDated,Food_Error,Food_Show,Pause,Pause_Pressed;
 signed char Snake_X[15],Snake_Y[15];
 unsigned int Timer,Level,Speed;
 unsigned char Snake_Size;
 signed int Food_X,Food_Y;
 unsigned char Ring;

void main() {

 ADCON1=0x06;
 TRISA=0xFF;
 TRISB=0x00;
 TRISC=0x00;
 TRISD=0x00;
 TRISE=0x00;

 Init_Game();
 Level = 500;

 while(1) {

 LATC=0;
 LATD=0;
  LATB = LATB <<1;
  LATB .F0=C_Bit;

 Read_Vectorial_Keys();
 Read_Function_Keys();

 ++Timer;
 if(Timer>=Speed) {

 Timer=0;
 Snake_UpDate();
 }
 Display_UpDate();

 delay_ms(1);
 }
}

void Display_UpDate() {

 if(! LATB.F0 ) {

 for(Ring=0;Ring<Snake_Size;Ring++) {

 if(Snake_X[Ring]==0) Display_Y_Select(Snake_Y[Ring]);
 if(Food_X==0 && Food_Show) Display_Y_Select(Food_Y);
 }
 }else if(! LATB.F1 ) {

 for(Ring=0;Ring<Snake_Size;Ring++) {

 if(Snake_X[Ring]==1) Display_Y_Select(Snake_Y[Ring]);
 if(Food_X==1 && Food_Show) Display_Y_Select(Food_Y);
 }
 }else if(! LATB.F2 ) {

 for(Ring=0;Ring<Snake_Size;Ring++) {

 if(Snake_X[Ring]==2) Display_Y_Select(Snake_Y[Ring]);
 if(Food_X==2 && Food_Show) Display_Y_Select(Food_Y);
 }
 }else if(! LATB.F3 ) {

 for(Ring=0;Ring<Snake_Size;Ring++) {

 if(Snake_X[Ring]==3) Display_Y_Select(Snake_Y[Ring]);
 if(Food_X==3 && Food_Show) Display_Y_Select(Food_Y);
 }
 }else if(! LATB.F4 ) {

 for(Ring=0;Ring<Snake_Size;Ring++) {

 if(Snake_X[Ring]==4) Display_Y_Select(Snake_Y[Ring]);
 if(Food_X==4 && Food_Show) Display_Y_Select(Food_Y);
 }
 }else if(! LATB.F5 ) {

 for(Ring=0;Ring<Snake_Size;Ring++) {

 if(Snake_X[Ring]==5) Display_Y_Select(Snake_Y[Ring]);
 if(Food_X==5 && Food_Show) Display_Y_Select(Food_Y);
 }
 }else if(! LATB.F6 ) {

 for(Ring=0;Ring<Snake_Size;Ring++) {

 if(Snake_X[Ring]==6) Display_Y_Select(Snake_Y[Ring]);
 if(Food_X==6 && Food_Show) Display_Y_Select(Food_Y);
 }
 }else if(! LATB.F7 ) {

 for(Ring=0;Ring<Snake_Size;Ring++) {

 if(Snake_X[Ring]==7) Display_Y_Select(Snake_Y[Ring]);
 if(Food_X==7 && Food_Show) Display_Y_Select(Food_Y);
 }
 }
}

void Display_Y_Select(signed char Y_Var) {

 switch(Y_Var) {

 case 0:  LATC.F0 =1; break;
 case 1:  LATC.F1 =1; break;
 case 2:  LATC.F2 =1; break;
 case 3:  LATC.F3 =1; break;
 case 4:  LATC.F4 =1; break;
 case 5:  LATC.F5 =1; break;
 case 6:  LATC.F6 =1; break;
 case 7:  LATC.F7 =1; break;
 case 8:  LATD.F0 =1; break;
 case 9:  LATD.F1 =1; break;
 case 10:  LATD.F2 =1; break;
 case 11:  LATD.F3 =1; break;
 case 12:  LATD.F4 =1; break;
 case 13:  LATD.F5 =1; break;
 case 14:  LATD.F6 =1; break;
 case 15:  LATD.F7 =1;
 }
}

void Snake_UpDate() {

 if(!Pause) {

 for(Ring=Snake_Size-1;Ring>0;Ring--) {

 Snake_X[Ring]=Snake_X[Ring-1];
 Snake_Y[Ring]=Snake_Y[Ring-1];
 }
 switch(Vectorial) {

 case UP: Snake_Y[0]-=1; break;
 case Down: Snake_Y[0]+=1; break;
 case RIGHT: Snake_X[0]+=1; break;
 case LEFT: Snake_X[0]-=1;
 }
 if(Snake_X[0]==Food_X && Snake_Y[0]==Food_Y) Snake_Incr();

 if(Snake_Size==15) Next_Level();

 Snake_Position_Check();
 Snake_UpDated = 1;
 Beep(10,0,1);
 }
 Food_Show= ~Food_Show;
}

void Read_Vectorial_Keys() {

 if(Snake_UpDated==1 && !Pause) {

 if(! PORTA.F0  && Vectorial!=DOWN) {

 Vectorial = UP;
 Snake_UpDated = 0;

 }else if(! PORTA.F1  && Vectorial!=UP) {

 Vectorial = DOWN;
 Snake_UpDated = 0;

 }else if(! PORTA.F2  && Vectorial!=LEFT) {

 Vectorial = RIGHT;
 Snake_UpDated = 0;

 }else if(! PORTA.F3  && Vectorial!=RIGHT) {

 Vectorial = LEFT;
 Snake_UpDated = 0;
 }
 }
}

void Read_Function_Keys() {

 if(! PORTA.F4 ) Speed = Level/2;
 else Speed = Level;

 if(! PORTA.F5  && !Pause_Pressed) {

 Pause_Pressed = 1;
 Pause = ~Pause;

 }else if( PORTA.F5 ) Pause_Pressed = 0;

}

void Beep(unsigned char ON_Time,unsigned char OFF_Time,unsigned char NUM_Time) {

 for(NUM_Time;NUM_Time>0;NUM_Time--) {

  LATE.F0  = 1;
 Vdelay_ms(ON_Time);
  LATE.F0  = 0;
 Vdelay_ms(OFF_Time);
 }
}

void Create_Food() {

 do {

 Food_X = rand()/4096;
 Food_Y = rand()/2048;
 Food_Error = 0;

 for(Ring=0;Ring<Snake_Size;Ring++) {

 if(Food_X==Snake_X[Ring] && Food_Y==Snake_Y[Ring]) {

 Food_Error = 1;
 break;
 }
 }
 }while(Food_Error==1);
}

void Snake_Incr() {

 ++Snake_Size;

 for(Ring=Snake_Size-1;Ring>0;Ring--) {

 Snake_X[Ring]=Snake_X[Ring-1];
 Snake_Y[Ring]=Snake_Y[Ring-1];
 }
 Create_Food();
 Beep(10,10,1);
}

void Snake_Position_Check() {

 if(Snake_X[0]>7 || Snake_X[0]<0 || Snake_Y[0]>15 || Snake_Y[0]<0) {

 Init_Game();
 Level = 500;

 }else {

 for(Ring=2;Ring<Snake_Size;Ring++) {

 if(Snake_X[0]==Snake_X[Ring] && Snake_Y[0]==Snake_Y[Ring]) {

 Init_Game();
 Level = 500;
 }
 }
 }
}

void Init_Game() {

 Vectorial = DOWN;
 Snake_Size = 4;

 Create_Food();

 Snake_X[3]=0;
 Snake_Y[3]=0;
 Snake_X[2]=0;
 Snake_Y[2]=1;
 Snake_X[1]=0;
 Snake_Y[1]=2;
 Snake_X[0]=0;
 Snake_Y[0]=3;

  LATB =254;

 Beep(10,10,3);
}

void Next_Level() {

 Init_Game();

 Level*=0.8;
 if(Level<10) Level = 500;

 Beep(50,50,4);
}
